#include <algorithm>
#include <list>
#include <queue>
#include <vector>
#include <string>
#include <cstdio>
#include <cmath>
#include <cstdlib>

using namespace std;

#define VAR(i,e) __typeof(e) i = (e)
#define FOREACH(i, c) for(VAR(i,(c).begin()); i != (c).end(); ++i)
#define ALL(c) (c).begin(), (c).end()

#define FORI(x, p) for(int i = x; i < p; ++i)
#define FORJ(x, p) for(int j = x; j < p; ++j)
#define FORK(x, p) for(int k = x; k < p; ++k)
#define FORL(x, p) for(int l = x; l < p; ++l)

#define PB push_back
#define MP make_pair
#define S size()
#define X first
#define Y second

#define LL long long

#define VI vector<int>
#define VS vector<string>

struct point{
    int x, y;
    inline bool operator==(const point & b)const{
	return (x == b.x && y == b.y);
    }
};

point pp0;

inline LL l2(const point & p1, const point & p2){
    return (p1.x - p2.x) *  (p1.x - p2.x) +  (p1.y - p2.y) *  (p1.y - p2.y);
}

inline bool rightside(const point & p1, const point & p2, const point & p3){
    return (0 > (p2.x - p1.x) * (p3.y - p2.y) - (p3.x - p2.x) * (p2.y - p1.y));
}

inline bool par(const point & p1, const point & p2, const point & p3){
    return (0 == (p2.x - p1.x) * (p3.y - p2.y) - (p3.x - p2.x) * (p2.y - p1.y));
}

inline list<point>::iterator next(list<point>::iterator it){
    return ++it;
}

inline list<point>::iterator prev(list<point>::iterator it){
    return --it;
}

inline list<point>::iterator next(list<point>::iterator it, list<point> & l){
    ++it;
    if(it == l.end())it = l.begin();
    return it;
}

list<point> hull(list<point> v){
//cerr << "hi" << endl;
    list<point>::iterator it = v.begin();
    list<point> res2;
    int pos = 0;
    bool used[500005];

    res2.push_front(*it);
    ++it;
    ++pos;
//    res2.push_front(*it);
//    ++it;
    while(next(it) != v.end() && par(*(v.begin()), *it, *next(it))){
	++it;
	++pos;
    }
    used[pos] = true;
    res2.push_front(*it);
    ++it;
    ++pos;

    if(it != v.end()){
        res2.push_front(*it);
        used[pos] = true;
	++it;
	++pos;
    }

    FORI(0, 500005)used[i] = false;
//    used[0] = true;
    while(it != v.end()){
	int bpos = pos - 1;
	while(res2.S > 1 && ! rightside(*(next(res2.begin())), *(res2.begin()), (*it))){
	    res2.pop_front();
	    used[bpos] = false;
	    --bpos;
	}
	used[pos] = true;
	++pos;
	res2.push_front(*it);
	++it;
    }
    --it;
    --pos;
    while(true){
	if(used[pos]){
	    if(it == v.begin())break;
	    --it;
	    --pos;
	    continue;
	}
	while(res2.S > 2 && ! rightside(*(next(res2.begin())), *(res2.begin()), (*it))){
	    res2.pop_front();
	}
        if(it == v.begin())break;
	res2.push_front(*it);

	--pos;
	--it;
    }
exit(0);
//    cerr << "hill" << endl;
//    FOREACH(jt, res2)cerr << ' ' << jt -> x << ' ' << jt -> y << endl;
//    cerr << endl;
    return res2;
}

LL count(list<point> l){
    if(l.S == 1)return 0;
    else if(l.S == 2)return l2(*(l.begin()), *(next(l.begin())));
    LL r = 0;
    list<point>::iterator it = l.begin();
    list<point>::iterator best = l.begin();
    FOREACH(jt, l){
	LL u = l2(*it, *best);
	LL v = l2(*it, *jt);
	if(v > u)best = jt;
    }

    FOREACH(it1, l){
	while(l2(*(next(best, l)), *it1) > l2(*it1, *best))
	    best = next(best, l);
	if(l2(*it1, *best) > r)r = l2(*it1, *best);
    }
    return r;
}

int main(){
    int d;
    scanf("%d", &d);
    FORL(0, d){
	list<point> l;
	int n;
	scanf("%d", &n);
//	cerr << n << ":" << endl;
	FORI(0, n){
	    point p;
	    scanf("%d %d", &p.x, &p.y);
	    l.push_back(p);
	}
	l.unique();
	if(l.S == 1)printf("0\n");
	else if(l.S == 2)printf("%lld\n", l2(*(l.begin()), *(next(l.begin()))));
	else printf("%lld\n", count(hull(l)));
    }
}
